(* Title:  BridgeJEdit/calculation.sml
   Author: Walther Neuper
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- build Outer_Syntax Example_TEST 1: parse errors shown at the spot -----------------";
"----------- build Outer_Syntax Example_TEST 2: handle empty input -----------------------------";
"----------- build Outer_Syntax Example_TEST 3: Pre_Conds.check_TEST I_Model.is_complete_OLD ---";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";


"----------- build Outer_Syntax Example_TEST 1: parse errors shown at the spot -----------------";
"----------- build Outer_Syntax Example_TEST 1: parse errors shown at the spot -----------------";
"----------- build Outer_Syntax Example_TEST 1: parse errors shown at the spot -----------------";
(*/-------------------- state of src/../preliminary.sml at that time --------------------------\*)
fun re_eval_all ((*dummyarg*)) = ("re_eval_all if new_thy"; ((*dummyarg*)))
fun re_eval_pbl ((*dummyarg*)) = ("re_eval_pbl"; ((*dummyarg*)))
fun re_eval_met ((*dummyarg*)) = ("re_eval_met"; ((*dummyarg*)))
;
re_eval_all: unit -> unit;
(*
  switch_pbl_met IS MISSING! Greater changes are to expect with respective introduction.
  In the meanwhile we just \<open>re_eval\<close> the \<open>I_Model\<close> of \<open>Problem\<close>;
  in case this is complete, we automatically complete the \<open>I_Model\<close> of \<open>MethodC\<close>
  without displaying the respective \<open>P_Model\<close> and immediately start solve-phase by \<open>Apply_Method\<close>;
*)
fun re_eval (input_thy, input_pbl, input_met) (spec_thy, spec_pbl, spec_met) =
  if spec_thy <> input_thy
    then re_eval_all ()
    else if spec_pbl <> input_pbl
      then re_eval_pbl ()
      else if spec_met <> input_met
        then re_eval_met ()
        else ("nothing to re-evaluate"; ((*dummyarg*)))
;
re_eval: References.T -> References.T -> unit;
(*\-------------------- state of src/../preliminary.sml at that time --------------------------/*)
(*/---------------------------------------- mimic input from PIDE -----------------------------\*)   
(* Example_TEST "Diff_App-No.123a" (*complete Model, empty References*) *)
val in_refs as (thy_id, probl_id, meth_id) = ("__", "__/__", "__/__")
val thy = @{theory Calculation}
val model_input = (*type Position.T is hidden, thus redefinition*)
 [("#Given", [("Constants [r = 7]", Position.none)]),
  ("#Where", [("0 < r", Position.none)]),
  ("#Find",
   [("Maximum A", Position.none), ("AdditionalValues [u, v]", Position.none)]),
  ("#Relate",
   [("Extremum (A = 2 * u * v - u \<up> 2)", Position.none),
    ("SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]", Position.none)])]
: (Model_Pattern.m_field * (string * Position.T) list) list
val example_id = "Diff_App-No.123a";
(*\---------------------------------------- mimic input from PIDE -----------------------------/*)
(*/---------------------------------------- adapt to Test_Isac/_Short.thy ---------------------\*)   
(**)val ctree = Preliminary.init_ctree thy example_id;
(** ) --- why does this not work? ( **)
set_data ctree thy;
the_data thy;
(** )-- why does this not work? Note (**)ctree(** )(the_data thy)( **) below.*)
(*\---------------------------------------- adapt to Test_Isac/_Short.thy ---------------------/*)
            val state =
              case the_data thy of
                  CTbasic_TEST.EmptyPtree => Preliminary.init_ctree thy example_id
                | _ => the_data thy
                (*let*)
                    val {origin = (_, o_ref, _), spec = spec_ref, ctxt, ...} =
                      CTbasic_TEST.get_obj I (**)ctree(** )(the_data thy)( **) [] |> CTbasic_TEST.rep_specify_data
                    val thy_id' = References.for_parse thy_id (#1 spec_ref) (#1 o_ref)
                    val (model, where_) = Model_Pattern.parse_pos ctxt model_input
(**)
                    val _ = re_eval References.empty References.empty;
(**)
            (*in*) Preliminary.update_state thy
                      (example_id, (model_input, (thy_id, probl_id, meth_id))) (the_data thy)
            (*end*);


"----------- build Outer_Syntax Example_TEST 2: handle empty input -----------------------------";
"----------- build Outer_Syntax Example_TEST 2: handle empty input -----------------------------";
"----------- build Outer_Syntax Example_TEST 2: handle empty input -----------------------------";
(*/---------------------------------------- mimic input from PIDE -----------------------------\*)
(* Example_TEST "Diff_App-No.123a" (*complete Model, empty References*) *)
val thy = @{theory}
val model_input = (*type Position.T is hidden, thus redefinition*)
 [("#Given", [("Constants [r = 7]", Position.none)]),
  ("#Where", [("0 < r", Position.none)]),
  ("#Find",
   [("Maximum A", Position.none), ("AdditionalValues [u, v]", Position.none)]),
  ("#Relate",
   [("Extremum (A = 2 * u * v - u \<up> 2)", Position.none),
    ("SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]", Position.none)])]
: (Model_Pattern.m_field * (string * Position.T) list) list
(**)
val ((thy_id, thy_id_pos), (probl_id, probl_id_pos), (meth_id, meth_id_pos)) =
  (("__", Position.none), ( "__/__", Position.none), ("__/__", Position.none))
(**)
val example_id = "Diff_App-No.123a";
(*\---------------------------------------- mimic input from PIDE -----------------------------/*)
open Model_Pattern

            val state =
              case the_data thy of
                  CTbasic_TEST.EmptyPtree => Preliminary.init_ctree thy example_id
                | _ => the_data thy
                  (*let*)
                    val {origin = (_, o_ref, _), spec = spec_ref, ctxt, ...} =
                      CTbasic_TEST.get_obj I state [(*Pos will become variable*)] |> CTbasic_TEST.rep_specify_data

(*knows variables from origin + notation (input) undefined ^^^^^ from BaseDefinitions.thy*)
(*test*)val Const ("Input_Descript.Constants", _) $
     (Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Const ("HOL.undefined", _) $ Const ("HOL.undefined", _)) $
       (Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Const ("HOL.undefined", _) $ Const ("HOL.undefined", _)) $
         Const ("List.list.Nil", _))) = Syntax.read_term ctxt "Constants [__=__, __=__]"

                    val thy_id' = References.for_parse thy_id (#1 spec_ref) (#1 o_ref)
(* here we assume:
  (1) thy_id did not provide an update
  (2) \<Otimes>\<Odot> is set to Problem_Ref
  (3) the probl : I_Model is complete with descriptors from Preliminary.init_ctree
*)
                    val (model, where_) =
Model_Pattern.parse_pos_empty ctxt model_input;
"~~~~~ fun parse_pos_empty , args:"; val (ctxt, model_input) = (ctxt, model_input);
    val items = model_input |> map (fn (m_field, items) => map (pair m_field) items) |> flat;
    val model = items 
      |> filter_out ((fn f => (fn (f', _) => f = f')) "#Where")
(*    |> map (parse_term ctxt) *)
(*val model =
   [("#Given", ("Constants [r = 7]", {})), ("#Find", ("Maximum A", {})), ("#Find", ("AdditionalValues [u, v]", {})), ("#Relate", ("Extremum (A = 2 * u * v - u \<up> 2)", {})),
    ("#Relate", ("SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]", {}))]:
   (string * (string * Position.T)) list*);

"~~~~~ fun parse_empty_input , args:"; val (ctxt, (m_field, (str, pos))) = (ctxt, hd model);
    val (m_field, term, pos) = parse_term ctxt (m_field, (str, pos));

(*+*)if is_undefined @{term "Constants [__=__, __=__]"}
(*+*)  then () else error "is_undefined 1 CHANGED";
(*+*)if is_undefined @{term "Maximum __"}
(*+*)  then () else error "is_undefined 2 CHANGED";
(*+*)if is_undefined @{term "AdditionalValues [__, __]"}
(*+*)  then () else error "is_undefined 3 CHANGED";
(*+*)if is_undefined @{term "Constants [r = 7]"}
(*+*)  then error "is_undefined 4 CHANGED" else ();

(*+*)val (m_field, (descr, arg), pos) = split_descriptor ctxt (m_field, term, pos);
(*+*)if is_undefined arg
(*+*)then Empty (m_field, (descr, descr |> empty_for), pos)
(*+*)else Proper (m_field, (descr, arg), pos);

                    val (model, where_) = Model_Pattern.parse_pos_empty ctxt model_input (*+check syntax*)
(*+*)val [Proper
(*+*)  ("#Given", (Const ("Input_Descript.Constants", _),
(*+*)    Const ("List.list.Cons", _) $ (Const ("HOL.eq", _) $ Free ("r", _) $
(*+*)      (Const ("Num.numeral_class.numeral", _) $ _)) $ Const ("List.list.Nil", _)), _),
(*+*) Proper _, Proper _, Proper _, Proper _] = model

(**)
                    val _ = re_eval References.empty References.empty;
(**)
            (*in*) Preliminary.update_state thy
                      (example_id, (model_input, (thy_id, probl_id, meth_id))) (the_data thy)
            (*end*);


"----------- build Outer_Syntax Example_TEST 3: Pre_Conds.check_TEST I_Model.is_complete_OLD ---";
"----------- build Outer_Syntax Example_TEST 3: Pre_Conds.check_TEST I_Model.is_complete_OLD ---";
"----------- build Outer_Syntax Example_TEST 3: Pre_Conds.check_TEST I_Model.is_complete_OLD ---";
(*/---------------------------------------- mimic input from PIDE -----------------------------\*)
(* Example_TEST "Diff_App-No.123a" (*complete Model, empty References*) *)
val thy = @{theory Calculation}
val model_input = (*type Position.T is hidden, thus redefinition*)
 [("#Given", [("Constants [r = 7]", Position.none)]),
  ("#Where", [("0 < r", Position.none)]),
  ("#Find",
   [("Maximum A", Position.none), ("AdditionalValues [u, v]", Position.none)]),
  ("#Relate",
   [("Extremum (A = 2 * u * v - u \<up> 2)", Position.none),
    ("SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]", Position.none)])]
: (Model_Pattern.m_field * (string * Position.T) list) list
(**)
val ((thy_id, thy_id_pos), (probl_id, probl_id_pos), (meth_id, meth_id_pos)) =
  (("__", Position.none), ( "__/__", Position.none), ("__/__", Position.none))
(**)
val example_id = "Diff_App-No.123a";
(*\---------------------------------------- mimic input from PIDE -----------------------------/*)
open Model_Pattern
open Pre_Conds
open I_Model

            val state =
              case the_data thy of
                  CTbasic_TEST.EmptyPtree => Preliminary.init_ctree thy example_id
                | _(*state (*FOR TEST*)*) => (**)the_data thy(**)
                  (*let*)
                    val {origin = (o_model, o_ref, _), spec = spec_ref, probl, meth, ctxt, ...} =
                      CTbasic_TEST.get_obj I state [(*Pos will become variable*)] |> CTbasic_TEST.rep_specify_data
                    val thy_id' = References.for_parse thy_id (#1 spec_ref) (#1 o_ref)
                    val (model, where_) = Model_Pattern.parse_pos_empty ctxt model_input (*+check syntax*);

(*+*)(o_model |> O_Model.to_string ctxt) = "[\n" ^
  "(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"]), \n" ^
  "(2, [\"1\", \"2\", \"3\"], #Find, Maximum, [\"A\"]), \n" ^
  "(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"]), \n" ^
  "(4, [\"1\", \"2\", \"3\"], #Relate, Extremum, [\"A = 2 * u * v - u \<up> 2\"]), \n" ^
  "(5, [\"1\", \"2\"], #Relate, SideConditions, [\"[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]\"]), \n" ^
  "(6, [\"3\"], #Relate, SideConditions, [\"[u / 2 = r * sin \<alpha>]\", \"[2 / v = r * cos \<alpha>]\"]), \n" ^
  "(7, [\"1\"], #undef, FunctionVariable, [\"a\"]), \n" ^
  "(8, [\"2\"], #undef, FunctionVariable, [\"b\"]), \n" ^
  "(9, [\"3\"], #undef, FunctionVariable, [\"\<alpha>\"]), \n" ^
  "(10, [\"1\", \"2\"], #undef, Input_Descript.Domain, [\"{0<..<r}\"]), \n" ^
  "(11, [\"3\"], #undef, Input_Descript.Domain, [\"{0<..<\<pi> / 2}\"]), \n" ^
  "(12, [\"1\", \"2\", \"3\"], #undef, ErrorBound, [\"\<epsilon> = 0\"])]";

(*//------------------ code under construction relate_to_input etc -------------------------\\*)
(* \<longrightarrow> calculation.sml (? preliminary.sml ?) *)
(* 
  each item of I_Model is related to input (NOT vice versa),
  where the input-items might be less in number than the I_Model-items
  due to error (msg ^ Position.here pos) in ParseC.term_position.
*)
fun relate_to_input o_model i_model input = 123
(*is known, which input -----------------------------(str, pos) is new ???*)
fun check_single ctxt m_field o_model i_model m_patt (str, pos) = 123;
(*\\------------------ code under construction relate_to_input etc -------------------------//*)

(*//------------------ test under construction relate_to_input etc -------------------------\\*)
"~~~~~ fun relate_to_input , args:"; val (o_model, i_model, input) = (o_model, probl, model);


"~~~~~ fun check_single , args:"; val (ctxt, m_field, o_model, i_model, (str, pos)) =
  (ctxt, "#Given", o_model, i_model, (str, Position.none));


(*\\------------------ test under construction relate_to_input etc -------------------------//*)

(*reminder for Template.show ----------------------------------------------------------------\*)
                    val ((_, true, _), (_, pbl_id as ["univariate_calculus", "Optimisation"], _)) =
                      References.for_eval_model (thy_id, probl_id, meth_id) spec_ref o_ref
                    val {model = model_patt, where_ = where_ctree, where_rls, ...} =
                      Problem.from_store ctxt pbl_id;

(*/----- ERROR: mk_env not reasonable for "Inc_TEST Constants [] [__=__, __=__]"-------------\
  ------------------------------------------------vvvvvvvvvvvvvvvvvvvvv-----------------------* )
                    val (_, env_eval) = Pre_Conds.sep_variants_envs_OLD model_patt probl
                    (*------------------- must be completed first ---^^^^^*)
                    val _ =
                      case I_Model.is_complete_OLD ctxt model_patt where_rls where_ctree probl of
                        NONE => writeln "I_Model.is_complete_OLD --> NONE"
                      | SOME variants =>
                        writeln ("I_Model.is_complete_OLD --> SOME " ^ LibraryC.ints2str' variants)
( *\----- ERROR: mk_env not reasonable for "Inc_TEST Constants [] [__=__, __=__]"-------------/*)
(*reminder for Template.show ----------------------------------------------------------------/*)

(*reminder for Pre_Conds.check_TEST ---------------------------------------------------------\* )
val (true, [(true, (Const ("Orderings.ord_class.less", _) $ Const ("Groups.zero_class.zero", _) $
  Free ("r", _), _))]) = Pre_Conds.check_TEST ctxt where_rls where_ env_eval;
( *reminder for Pre_Conds.check_TEST ---------------------------------------------------------/*)
(**)
                    val ((_, true, _), (_, pbl_id as ["univariate_calculus", "Optimisation"], _)) =
                        References.for_eval_model (thy_id, probl_id, meth_id) spec_ref o_ref
                    val _ = re_eval References.empty References.empty;
(**)
            (*in*)
                    Preliminary.update_state thy
                      (example_id, (model_input, (thy_id, probl_id, meth_id))) (the_data thy)
            (*end*)
